#
# spec file for package perl-Devel-Size
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           perl-Devel-Size
Version:        0.82
Release:        1.1
%define cpan_name Devel-Size
Summary:        Perl extension for finding the memory usage of Perl variables
License:        Artistic-1.0 OR GPL-1.0-or-later
Group:          Development/Libraries/Perl
Url:            http://search.cpan.org/dist/Devel-Size/
Source0:        https://cpan.metacpan.org/authors/id/N/NW/NWCLARK/%{cpan_name}-%{version}.tar.gz
Source1:        cpanspec.yml
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
%{perl_requires}

%description
This module figures out the real size of Perl variables in bytes, as
accurately as possible.

Call functions with a reference to the variable you want the size of. If
the variable is a plain scalar it returns the size of this scalar. If the
variable is a hash or an array, use a reference when calling.

%prep
%setup -q -n %{cpan_name}-%{version}

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
%{__make} %{?_smp_mflags}

%check
%{__make} test

%install
%perl_make_install
%perl_process_packlist
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc CHANGES README

%changelog
* Sun Jun 24 2018 coolo@suse.com
- updated to 0.82
  see /usr/share/doc/packages/perl-Devel-Size/CHANGES
* Sun Aug  6 2017 coolo@suse.com
- updated to 0.81
  see /usr/share/doc/packages/perl-Devel-Size/CHANGES
  0.81 2015-08-05 nicholas
  [no changes]
  0.80_50 2017-06-21 nicholas
  * Attempt to fix strange 1 == 1 failures on some older threaded perls.
* Thu Apr 16 2015 coolo@suse.com
- updated to 0.80
  see /usr/share/doc/packages/perl-Devel-Size/CHANGES
  0.80 2015-03-31 nicholas
  [no changes]
  0.79_54 2015-03-27 nicholas
  * Fix the definition of padlist_size() for post-5.20 perls.
  * Avoid tests failing because Test::More lazy-loading changes the size of %%::
  * Fix the build under 5005 threads. [Not that anyone is using them :-)]
  0.79_53 2015-03-25 nicholas
  * Avoid t/recurse.t failing on earlier versions on 32 bit platforms
    (subroutines are smaller than it assumes)
  * Count the size of padlist names in CVs (for v5.18 and later - earlier TODO)
  * Handle PADNAMELIST/PADNAME introduced in v5.21.7
    two patches from Zefram:
  * Add handling of children of METHOP and UNOP_AUX ops [CPAN #102911]
  * More complete handling of padlists for XSUBs [CPAN #102909]
  0.79_52 2015-03-20 nicholas
    two patches from Zefram:
  * handle the new METHOP. [CPAN #101071]
  * handle the multideref op, and to a limited extent the UNOP_AUX op class in
    general. [CPAN #102911]
  * As of eacbb37937698a03 (v5.21.6), can't call CvPADLIST on an XSUB.
    More usefully, the slot is now used for XS versioning protection, which
    means that we can be confident that nothing out there is using it for data.
    Reported as [CPAN #102909].
  * Avoid t/recurse.t failing because Test::More::is() has been refactored and
    is now larger than it was. [CPAN #102910].
  0.79_51 2015-02-28 nicholas
  * as of 5.20.0, s/// is no longer a reliable test for OOK [CPAN #95493]
  0.79_50 2015-02-28 nicholas
    patches from Zefram:
  * wrong test for magicalness [CPAN #88180]
  * reading tied scalar shrinks it [CPAN #88182]
  0.79 2013-05-12 nicholas
  [no changes]
  0.78_52 2013-05-10 nicholas
  * Fix the bug in the previous fix. Oops :-)
  0.78_51 2013-05-10 nicholas
  * v5.17.1 and later handle CopSTASH differently under ithreads
  0.78_50 2013-05-10 nicholas
  * Alternative test for CvOUTSIDE, and one for CvPADLIST
  * v5.17 changes the type of PADLIST [CPAN #83904]
  * stubbed subs no longer have CvOUTSIDE set [CPAN #77913]
  * Fix for v5.17.2's OP slab allocator [CPAN #83903]
  * Spelling fix to docs from gregor herrmann [CPAN #78766]
  0.78 2012-07-26 nicholas
  [no changes]
  0.77_51 2012-07-17 nicholas
  * Fix for MSVC builds from bulk 88 [CPAN #77589]
  0.77_50 2012-02-10 nicholas
  * t/globs.t was failing on 5.15.6 and later due to side effects of a change
    to strict.pm [CPAN #73998]
  * skip tests in t/magic.t that use formline on 5.8.1 and 5.8.2, as those
    versions have a buggy formline that can trigger an assertion failure.
* Tue May 31 2011 coolo@novell.com
- updated to 0.77
  * Split out HEK size calculation into hek_size(). Add the shared HE overhead.
  * Handle shared hash key scalars correctly.
  * GvNAME() is shared from 5.10 onwards.
  * Count HvNAME(), the HV "aux" struct, the mro_meta struct, and ENAMEs.
  0.75_52 2011-05-09 nicholas
  * Use a table for SV body sizes. These incorporate the space saving post 5.8.x
  * Correctly handle SvOOK scalars. 5.12 and later don't use SvIVX().
  * Magic vtables aren't freed when magic is freed, so don't count them.
  (They are static structures. Anything that assumes otherwise is buggy.)
  * Reinstate 5.6.x "support". (i.e. it compiles and passes tests.)
  * Reinstate 5.005_xx "support". (i.e. it compiles and passes tests.)
  0.75_51 2011-05-05 nicholas
  * Only use a static array of vtables on gcc.
  0.75_50 2011-05-04 nicholas
  * The core's magic vtables are global constants, so aren't part of the size.
  * Follow mg_obj and mg_ptr.
  0.74_53 2011-05-01 nicholas
  * Fix typo error in bit-vector tracking mechanism. On 64 bit platforms which
  allocate on 8 byte alignment (rather than 16), a low pointer bit could get
  lost, resulting in new pointers being considered already "seen".
  "Found" by BinGOs' smoker, fixed on spectre.mongueurs.net. Thanks.
  0.74_52 2011-04-23 nicholas
  * Fix potential SEGVs for OP_AELEMFAST on a lexical (eg $foo[3])
  * Fix likely SEGVs for PVOPs (missing break)
  * Fix potential SEGVs for PVBMs on 5.10 and later
  * Move hash and array traversal from total_size() to sv_size()
  - this allows total_size() and size() to be XS ALIASes.
  0.74_51 2011-04-22 nicholas
  * Don't count PL_sv_{undef,no,yes} in the size returned
  * total_size() was double-counting entries in typeglobs
  * sv_size() was double-counting the PVGV size if GvEGV() looped back
  * fix classic off-by-one error - the answer is strlen() + 1, not just strlen()
  0.74_50 2011-04-19 nicholas
  * Ensure that size() doesn't add the referent's size for non SVt_RV references
* Fri Apr 22 2011 coolo@opensuse.org
- updated to 0.74
  * Correct the Makefile.PL - LICENSE was added to ExtUtils::MakeMaker in 6.31
  * Refactor the C code to accumulate the size inside the tracking structure
  - this means that the C *_size() functions now return void
  - The XS functions size() and total_size() now return UV, not IV
  * Avoid using assert() on ithreaded 5.8.8 and earlier, as it needs my_perl
  * Fix the test added in 0.73, as it tripped over a combination of bugs
  * Revert a bad assertion introduced in 0.72_50, which was logically wrong.
  - and a test to demonstrate one case that would trigger it
  * Add a test for the non-exceptional warnings.
  * Add PERL_NO_GET_CONTEXT to improve performance under multiplicity
  * Exception handling is totally MSVC specific, so only use it there
  - this means that we don't need to use a C++ compiler anywhere
  * Rework bit-vector tracking mechanism to use a 256-way tree. This avoids
    making assumptions about 64-bit platforms' memory layouts, and eliminates
    the fatal error introduced in 0.72 when the assumption was violated.
  * Convert to XSLoader
  * Resolve CPAN #49437 (Devel::Size adds magic in Perl 5.10)
  * Resolve CPAN #58484 and #58485 (related to CVs that are XSUBs)
  * Added bit-vector pointer tracking mechanism.
  - new fatal error (64-bit platforms only)
  * Added exception handling
  - 4 new warnings (disabled by default)
  * Updated POD to reflect above
  * Added basic.t test 13
  * replaced Module::Install with hand crafted EU::MM Makefile.pl
    (With many thanks to Sisyphus)
    because we couldn't work out how to add C++ options to allow
    exception handling.
* Wed Dec  1 2010 coolo@novell.com
- switch to perl_requires macro
* Wed Nov 18 2009 hvogel@novell.com
- Initial Package, Version 0.71
